darcs-2.12.5: a distributed, interactive, smart revision control system

Safe Haskell | None
Language | Haskell2010

Darcs.Patch.MonadProgress

Synopsis

- class Monad m => MonadProgress m where
- data ProgressAction m a = ProgressAction {
  - paAction :: m a
  - paMessage :: Doc
  - paOnError :: Doc
  }
- silentlyRunProgressActions :: Monad m => String -> [ProgressAction m ()] -> m ()

# Documentation

class Monad m => MonadProgress m where #

Minimal complete definition

runProgressActions

Methods

runProgressActions :: String -> [ProgressAction m ()] -> m () #

run a list of `ProgressAction`s. In some monads (typically IO-based ones), the progress and error messages will be used. In others they will be ignored and just the actions will be run.

Instances

MonadProgress DefaultIO # |
Methods runProgressActions :: String -> [ProgressAction DefaultIO ()] -> DefaultIO () #
(Functor m, Monad m) => MonadProgress (TreeMonad m) # |
Methods runProgressActions :: String -> [ProgressAction (TreeMonad m) ()] -> TreeMonad m () #

data ProgressAction m a #

a monadic action, annotated with a progress message that could be printed out while running the action, and a message that could be printed out on error. Actually printing out these messages is optional to allow non-IO monads to just run the action.

Constructors

ProgressAction |
Fields paAction :: m a paMessage :: Doc paOnError :: Doc

silentlyRunProgressActions :: Monad m => String -> [ProgressAction m ()] -> m () #

run a list of `ProgressAction`s without any feedback messages